package Pair;

import java.util.ArrayList;
import java.util.Collections;

/**
 * In here you must make firstLast, which will return a pair of the first element in the array list and the last
 * element in the arraylist.
 * You must also make a min method that returns the smallest item in the array list
 * A max method that returns the largest item in the arraylist
 * And a minmax method that returns a pair containing the largest and smallest items from the array list
 */
public class Arrays {
    public static <E extends Comparable> Pair<E> firstLast(ArrayList<E> a) {
        Comparable first = a.get(0);
        Comparable second = a.get(a.size()-1);
        return new Pair(first, second);
    }

    public static <E extends Comparable> Pair<E> minMax(ArrayList<E> al) {
        return new Pair<E>(min(al),max(al));
    }

    public static <E extends Comparable> E max(ArrayList<E> al) {
        E tempMax = al.get(0);
        for (int i=1; i<al.size(); i++){
            if (al.get(i).compareTo(tempMax)>0){
                tempMax = (E)al.get(i);
            }
        }
        return tempMax;
    }

    public static <E extends Comparable> E min(ArrayList<E> al) {
        E tempMin = (E)al.get(0);
        for (int i=1; i<al.size(); i++){
            if (al.get(i).compareTo(tempMin)<0){
                tempMin = (E)al.get(i);
            }
        }
        return tempMin;
    }
}
