package StackArray;

import java.util.Arrays;

/**
 * Expand the ArrayList implementation of stack here to use an Object[] array.  Still implement push, pop, and isEmpty.
 * Remember, you might need to resize the stack in the push method.
 * @param <E>
 */
public class ObjectStack<E> {
    private Object[] elements = new Object[0];

    public ObjectStack() { }

    public boolean isEmpty() {
        return elements.length==0;
    }

    public void push(E foobar) {
        Object[] newArray = Arrays.copyOf(elements, elements.length+1);
        newArray[elements.length] = foobar;
        this.elements = newArray;
    }

    public Object pop() throws IndexOutOfBoundsException {
        Object removed = elements[elements.length-1];
        Object[] newArray = Arrays.copyOf(elements, elements.length-1);
        this.elements = newArray;
        return removed;
    }
}
