package StackArray;

import java.util.Arrays;

/**
 * Expand the ArrayList implementation of stack here to use an E[] array.  Still implement push, pop, and isEmpty.
 * Remember, you might need to resize the stack in the push method.
 * @param <E>
 */
public class GenericStack<E> {
    private E[] elements = (E[])new Object[0];

    public GenericStack() {
    }

    public boolean isEmpty() {
        return elements.length==0;
    }

    public void push(E foobar) {
        E[] newArray = Arrays.copyOf(elements, elements.length+1);
        newArray[elements.length] = foobar;
        this.elements = newArray;
    }

    public E pop() throws IndexOutOfBoundsException {
        E removed = elements[elements.length-1];
        E[] newArray = Arrays.copyOf(elements, elements.length-1);
        this.elements = newArray;
        return removed;
    }
}
